## $Id$

%bcond_with	minit
%bcond_with	initng
%bcond_without	lsb
%bcond_without	xinetd
%bcond_without	ssh


%global pkgdatadir	%_datadir/%name
%global logfile		%_var/log/distccd.log
%global username	distcc

%{!?release_func:%global release_func() %1%{?dist}}

Name:		distcc
Version:	2.18.3
Release:	%release_func 1.7
Summary:	A free distributed C/C++ compiler system

Group:		Development/Tools
License:	GPL
URL:		http://distcc.samba.org/
Source0:	http://distcc.samba.org/ftp/distcc/%name-%version.tar.bz2
Source1:	http://distcc.samba.org/ftp/distcc/%name-%version.tar.bz2.asc
Source10:	distcc.sh
BuildRoot:	%_tmppath/%name-%version-%release-root-%(%__id_u -n)

BuildRequires:			python popt
Requires(triggerin):		coreutils
Requires(triggerpostun):	coreutils
Requires(preun):		coreutils

%package gnome
Summary:	Gnome tools for distcc
Group:		Applications/System
# The base package is not required but prevent version mix
Conflicts:	%name < %version-%release
Conflicts:	%name > %version-%release
BuildRequires:	libgnomeui-devel
BuildRequires:	desktop-file-utils
Requires(post):	gtk2

%package server
Summary:	The distcc daemon
Group:		System Environment/Daemons
## Do not require an init-method for now; 'initng' provides already a
## distcc initscript but not the required 'init(%name)'.
# Requires:	init(%name)
## The base package is not required but prevent version mix
Conflicts:	%name < %version-%release
Conflicts:	%name > %version-%release
BuildRequires:		fedora-usermgmt-devel
Provides:		user(%username)
Provides:		group(%username)
Requires(pre):		/etc/logrotate.d
Requires(postun):	/etc/logrotate.d
Requires(missingok):	logrotate
%{?FE_USERADD_REQ}

%package server-initng
Summary:	initng initscripts for the distcc daemon
Group:		System Environment/Base
Source40:	distccd.i
Provides:	init(%name) = initng
Requires:	%name-server = %version-%release
## Current 'initng' package contains already a distccd initscript
Conflicts:	initng

%package server-lsb
Summary:	LSB initscripts for the distcc daemon
Group:		System Environment/Base
Source20:	distccd.lsb
Source21:	distccd.sysconfig
Provides:	init(%name) = lsb
Requires:	lsb
Requires:	%name-server = %version-%release
Requires(post):	%name-server
Requires(post):		lsb
Requires(preun):	lsb
Requires(pre):		%_initrddir group(%username)
Requires(postun):	%_initrddir

%package server-minit
Summary:	minit initscripts for the distcc daemon
Group:		System Environment/Base
Source30:	params.minit
Provides:	init(%name) = lsb
Requires:		%name-server = %version-%release
Requires(pre):		minit-setup
Requires(postun):	minit-setup

%package server-xinetd
Summary:	xinetd initscripts for the distcc daemon
Group:		System Environment/Base
Provides:	init(%name) = xinetd
Requires:	xinetd
Requires:	%name-server = %version-%release

%package server-ssh
Summary:	SSH setup for the distcc daemon
Group:		System Environment/Base
Provides:	init(%name) = ssh
Requires:	openssh-server
Requires:	%name-server = %version-%release


%description
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.


%description gnome
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains a GNOME2 frontend to monitor the distcc tasks.


%description server
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains the 'distccd' daemon


%description server-initng
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains initng compliant initscripts for 'distccd'.

NOTE: This package conflicts with 'initng' of Fedora Extras because
the required scripts are already provided there.


%description server-lsb
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains LSB compliant initscripts for 'distccd'.


%description server-minit
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains minit compliant initscripts for 'distccd'.


%description server-xinetd
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains xinetd scripts for 'distccd'.


%description server-ssh
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains ssh setup for 'distccd'.


%prep
%setup -q

# removal of '"' is the main reason for the patch, not the %logfile...
sed -i -e 's!"/var/log/distccd.log"!%logfile!g'	\
	contrib/redhat/xinetd


%build
%configure --with-gnome --enable-rfc2553
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT _doc
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT{%_sysconfdir/{sysconfig,profile.d,minit/services/distccd,initng/daemon}}	\
	 $RPM_BUILD_ROOT{%_initrddir,%pkgdatadir/bin} 							\
	 $RPM_BUILD_ROOT{%_sysconfdir/{logrotate.d,xinetd.d},%_var/{run/distccd,log}}			\
	 $RPM_BUILD_ROOT%_datadir/icons/hicolor/48x48/apps

install -p -m0644 %SOURCE10 $RPM_BUILD_ROOT%_sysconfdir/profile.d/

mv $RPM_BUILD_ROOT%_datadir/doc/%name _doc
rm -rf _doc/example

## The gnome stuff
desktop-file-install --vendor fedora -m644 --delete-original	\
  --dir $RPM_BUILD_ROOT%_datadir/applications			\
  --add-category X-Fedora					\
  $RPM_BUILD_ROOT%_datadir/%name/distccmon-gnome.desktop

ln $RPM_BUILD_ROOT%pkgdatadir/distccmon-gnome-icon.png		\
   $RPM_BUILD_ROOT%_datadir/icons/hicolor/48x48/apps


## The initng stuff
install -p -m0644 %SOURCE40 $RPM_BUILD_ROOT%_sysconfdir/initng/daemon/distccd.i


## The LSB stuff
install -p -m0755 %SOURCE20 $RPM_BUILD_ROOT%_initrddir/distccd
install -p -m0644 %SOURCE21 $RPM_BUILD_ROOT%_sysconfdir/sysconfig/distccd


## The minit stuff
d=$RPM_BUILD_ROOT%_sysconfdir/minit/services/distccd
install -p -m0644 %SOURCE30 $d/params
touch $d/respawn
ln -s /usr/bin/distccd $d/run

## The xinetd stuff
install -p -m0644 contrib/redhat/xinetd    $RPM_BUILD_ROOT%_sysconfdir/xinetd.d/distccd

## The logrotate stuff
install -p -m0644 contrib/redhat/logrotate $RPM_BUILD_ROOT%_sysconfdir/logrotate.d/distccd
touch $RPM_BUILD_ROOT%logfile


%{!?with_lsb:   rm -rf $RPM_BUILD_ROOT%_initrddir}
%{!?with_minit: rm -rf $RPM_BUILD_ROOT%_sysconfdir/minit}
%{!?with_initng:rm -rf $RPM_BUILD_ROOT%_sysconfdir/initng}
%{!?with_xinetd:rm -rf $RPM_BUILD_ROOT%_sysconfdir/xinetd.d}


%global handled_progs	gcc g++ cc c++ gcc296 g++296 gcc32 c++32 g++32 gcc34 c++34 g++34
%global handled_pkgs	gcc, gcc-c++, compat-gcc, compat-gcc-c++, compat-gcc-32, compat-gcc-32-c++, gcc34, gcc34-c++
%triggerin -- %handled_pkgs
for name in %handled_progs; do
  for c in $name %_target_cpu-%_target_vendor-%_target_os-$name ; do
    [ ! -x /usr/bin/$c ] || ln -sf %_bindir/distcc %pkgdatadir/bin/$c
  done
done

%triggerpostun -- %handled_pkgs
for name in %handled_progs; do
  for c in $name %_target_cpu-%_target_vendor-%_target_os-$name ; do
    [ -x /usr/bin/$c ] || rm -f %pkgdatadir/bin/$c
  done
done


%preun
test "$1" -ne 0 || rm -f %pkgdatadir/bin/*



%post gnome
gtk-update-icon-cache -qf /usr/share/icons/hicolor 2>/dev/null || :

%postun gnome
gtk-update-icon-cache -qf /usr/share/icons/hicolor 2>/dev/null || :


%pre server
%__fe_groupadd 17 -r %username &>/dev/null || :
%__fe_useradd  17 -r  -s /sbin/nologin -M -d %pkgdatadir	\
	          -c 'distcc user' -g %username %username &>/dev/null || :


%post server
test -e '%logfile' || {
	touch '%logfile'
	chown root:%username '%logfile'
	chmod 0620 '%logfile'
}


%postun server
%__fe_userdel  %username &>/dev/null || :
%__fe_groupdel %username &>/dev/null || :


%post server-lsb
/usr/lib/lsb/install_initd %_initrddir/distccd

%preun server-lsb
test "$1" != 0 || {
	%_initrddir/distccd stop &>/dev/null || :
	/usr/lib/lsb/remove_initd %_initrddir/distccd
}

%postun server-lsb
test "$1"  = 0 || %_initrddir/distccd try-restart &>/dev/null


%clean
rm -rf $RPM_BUILD_ROOT


%files
  %defattr(-,root,root,-)
  %doc _doc/*
  %config %_sysconfdir/profile.d/*
  %_bindir/distcc
  %_bindir/distccmon-text
  %_mandir/man1/distcc.*
  %_mandir/man1/distccmon-text.*
  %dir %pkgdatadir
  %dir %pkgdatadir/bin

%files gnome
  %defattr(-,root,root,-)
  %_bindir/distccmon-gnome
  %_datadir/applications/*.desktop
  %_datadir/icons/hicolor/48x48/apps/*gnome*.png
  %pkgdatadir/distccmon-gnome-icon.png
  # ignore ownership of the %_datadir/icons/... directories; Core is
  # too broken to add good Requires(pre/postun).

%files server
  %defattr(-,root,root,-)
  %_bindir/distccd
  %_mandir/man1/distccd.*
  %config(noreplace) %_sysconfdir/logrotate.d/distccd
  %attr(0620,root,%username) %config %ghost %logfile

%if 0%{?with_initng:1}
%files server-initng
  %defattr(-,root,root,-)
  %config(noreplace) %_sysconfdir/initng/daemon/distccd.i
%endif

%if 0%{?with_lsb:1}
%files server-lsb
  %defattr(-,root,root,-)
  %config %_initrddir/distccd
  %config(noreplace) %_sysconfdir/sysconfig/distccd
  %dir %attr(0775,root,%username) %_var/run/distccd
%endif

%if 0%{?with_minit:1}
%files server-minit
  %defattr(-,root,root,-)
  %dir %_sysconfdir/minit/services/distccd
  %config(noreplace) %_sysconfdir/minit/services/distccd/params
  %_sysconfdir/minit/services/distccd/respawn
  %_sysconfdir/minit/services/distccd/run
%endif

%if 0%{?with_xinetd:1}
%files server-xinetd
  %defattr(-,root,root,-)
  %config(noreplace) %_sysconfdir/xinetd.d/distccd
%endif

%if 0%{?with_ssh:1}
%files server-ssh
  %defattr(-,root,root,-)
%endif


%changelog
* Wed Aug 16 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 2.18.3-1.7
- simplified LSB initscripts and support only one $DISTCC_OPTS variable
- ship sample sysconfig file for LSB
- use rpm macros to create the platform tuple instead of hardcoding
  'i386-redhat-linux'

* Wed Aug  9 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 2.18.3-1.6
- bound a %%postun script to -gnome subpackage
- use %%bcond* macros

* Sun Jul  9 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 2.18.3-1.5
- updated to new fedora-usermgmt code
- updated to new ccache path
- added distccmon-gnome-icon.png to the pkgdatadir

* Mon Mar  6 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 2.18.3-1.3
- added 'desktop-file-utils' BR
- moved the gnome icon the a common place
- added -server-xinetd subpackage
- added -server-ssh subpackage for ssh-setup
- added logrotate support

* Sat Nov 26 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 2.18.3-0.6
- initial built
